Index: /trunk/UTIL/PYTHON/README.PP
===================================================================
--- /trunk/UTIL/PYTHON/README.PP	(revision 452)
+++ /trunk/UTIL/PYTHON/README.PP	(revision 453)
@@ -53,4 +53,7 @@
 Goal: I want the same map, but projected with north polar stereographic view
 pp.py -f diagfired.nc -v tauice -m 0.2 -M 0.9 -H -b vishires -p npstere
+
+Goal: I want the same map, but with a transparent field to see background image 
+pp.py -f diagfired.nc -v tauice -m 0.2 -M 0.9 -H -b vishires -p npstere --trans 0.6
 
 Goal: I want to save this in PNG format
Index: /trunk/UTIL/PYTHON/myplot.py
===================================================================
--- /trunk/UTIL/PYTHON/myplot.py	(revision 452)
+++ /trunk/UTIL/PYTHON/myplot.py	(revision 453)
@@ -196,11 +196,11 @@
         subh = 99999
     elif numplot == 2:
-        subv = 1
-        subh = 2
+        subv = 2
+        subh = 1
         fig.subplots_adjust(wspace = 0.35)
         rcParams['font.size'] = int( rcParams['font.size'] * 3. / 4. )
     elif numplot == 3:
-        subv = 2
-        subh = 2
+        subv = 3
+        subh = 1
         fig.subplots_adjust(wspace = 0.5)
         rcParams['font.size'] = int( rcParams['font.size'] * 1. / 2. )
@@ -228,5 +228,5 @@
         subv = 3
         subh = 4
-        fig.subplots_adjust(wspace = 0.1, hspace = 0.1)
+        fig.subplots_adjust(wspace = 0, hspace = 0.1)
         rcParams['font.size'] = int( rcParams['font.size'] * 1. / 2. )
     elif numplot <= 16:
@@ -559,5 +559,5 @@
     if blat is None:
         ortholat=meanlat
-        if   wlat[0] >= 80.:   blat =  40. 
+        if   wlat[0] >= 80.:   blat =  -40. 
         elif wlat[1] <= -80.:  blat = -40.
         elif wlat[1] >= 0.:    blat = wlat[0] 
@@ -586,9 +586,15 @@
     else:                                             step = 10.
     steplon = step*2.
-    #if back in ["geolocal"]:                          
-    #    step = np.min([5.,step])
-    #    steplon = step
-    m.drawmeridians(np.r_[-180.:180.:steplon], labels=[0,0,0,1], color='grey', fontsize=fontsizemer)
-    m.drawparallels(np.r_[-90.:90.:step], labels=[1,0,0,0], color='grey', fontsize=fontsizemer)
+    zecolor ='grey'
+    zelinewidth = 1
+    zelatmax = 80
+    # to show gcm grid:
+    #zecolor = 'r'
+    #zelinewidth = 1
+    #step = 5.625
+    #steplon = 5.625
+    #zelatmax = 89.9
+    m.drawmeridians(np.r_[-180.:180.:steplon], labels=[0,0,0,1], color=zecolor, linewidth=zelinewidth, fontsize=fontsizemer, latmax=zelatmax)
+    m.drawparallels(np.r_[-90.:90.:step], labels=[1,0,0,0], color=zecolor, linewidth=zelinewidth, fontsize=fontsizemer, latmax=zelatmax)
     if back: m.warpimage(marsmap(back),scale=0.75)
             #if not back:
@@ -770,4 +776,5 @@
              "VMR_H2OICE":   "PuBu",\
              "VMR_H2OVAP":   "PuBu",\
+             "WATERCAPTAG":  "Blues",\
                      }
 #W --> spectral ou jet
@@ -810,4 +817,7 @@
 		#"mola":	"http://www.lns.cornell.edu/~seb/celestia/mars-mola-2k.jpg",\
 		#"molabw":	"http://dl.dropbox.com/u/11078310/MarsElevation_2500x1250.jpg",\
+                "thermalday":   domain+"thermalday.jpg",\
+                "thermalnight": domain+"thermalnight.jpg",\
+                "tesalbedo":    domain+"tesalbedo.jpg",\
                 "vis":         domain+"mar0kuu2.jpg",\
                 "vishires":    domain+"MarsMap_2500x1250.jpg",\
Index: /trunk/UTIL/PYTHON/myscript.py
===================================================================
--- /trunk/UTIL/PYTHON/myscript.py	(revision 452)
+++ /trunk/UTIL/PYTHON/myscript.py	(revision 453)
@@ -30,4 +30,5 @@
     parser.add_option('-T', '--tiled',  action='store_true',dest='tile',                 default=False, help='draw a tiled plot (no blank zone)')
     parser.add_option('--res',          action='store',dest='res',       type="float",   default=200.,  help='Resolution for png outputs. --save png needed. [200.]')
+    parser.add_option('--trans',        action='store',dest='trans',     type="float",   default=1.,    help='shaded plots transparency, from 0 (transparent) to 1 (opaque) [1]')
 
     ### SPECIFIC FOR MAPPING [MAPMODE 1]
Index: /trunk/UTIL/PYTHON/planetoplot.py
===================================================================
--- /trunk/UTIL/PYTHON/planetoplot.py	(revision 452)
+++ /trunk/UTIL/PYTHON/planetoplot.py	(revision 453)
@@ -55,5 +55,6 @@
            flagnolow=False,\
            mrate=None,\
-           mquality=False):
+           mquality=False,\
+           trans=1):
 
 
@@ -363,9 +364,9 @@
                             #zelevels = np.linspace(zevmin*(1. + 1.e-7),zevmax*(1. - 1.e-7)) #,num=20)
                             zelevels = np.linspace(zevmin,zevmax,num=ticks)
-                            if mapmode == 1:       m.contourf( x, y, what_I_plot_frame, zelevels, cmap = palette)
-                            elif mapmode == 0:     contourf( x, y, what_I_plot_frame, zelevels, cmap = palette)
+                            if mapmode == 1:       m.contourf( x, y, what_I_plot_frame, zelevels, cmap = palette, alpha=trans)
+                            elif mapmode == 0:     contourf( x, y, what_I_plot_frame, zelevels, cmap = palette, alpha=trans)
                         else:
-                            if mapmode == 1:       m.pcolor( x, y, what_I_plot_frame, cmap = palette, vmin=zevmin, vmax=zevmax )
-                            elif mapmode == 0:     pcolor( x, y, what_I_plot_frame, cmap = palette, vmin=zevmin, vmax=zevmax )
+                            if mapmode == 1:       m.pcolor( x, y, what_I_plot_frame, cmap = palette, vmin=zevmin, vmax=zevmax ,alpha=trans)
+                            elif mapmode == 0:     pcolor( x, y, what_I_plot_frame, cmap = palette, vmin=zevmin, vmax=zevmax ,alpha=trans)
                         if colorb != 'nobar':        
                             if (fileref is not None) and (index_f is numplot-1):   daformat = "%.3f"
Index: /trunk/UTIL/PYTHON/pp.py
===================================================================
--- /trunk/UTIL/PYTHON/pp.py	(revision 452)
+++ /trunk/UTIL/PYTHON/pp.py	(revision 453)
@@ -140,5 +140,6 @@
                 ope=opt.operat,fileref=reffile,minop=opt.vminope,maxop=opt.vmaxope,titleref=opt.titref,\
                 invert_y=opt.inverty,xaxis=zexaxis,yaxis=zeyaxis,ylog=opt.logy,yintegral=opt.column,\
-                blat=opt.blat,blon=opt.blon,tsat=opt.tsat,flagnolow=opt.nolow,mrate=opt.rate,mquality=opt.quality)
+                blat=opt.blat,blon=opt.blon,tsat=opt.tsat,flagnolow=opt.nolow,\
+                mrate=opt.rate,mquality=opt.quality,trans=opt.trans)
         print 'DONE: '+name
         system("rm -f to_be_erased")